#!/usr/bin/perl

# this shows the games played by the best bots
#
#
#  Player        Bot A              Bot B          Score
#            Gold   Silv        Gold   Silv      BotA BotB
# --------------------------------------------------------
#          |      |           |      |
#  omar     * g 32   g 43       g 29   * g 45      1   1


###########################
# setup the functions we need from the gameroom

$curdir = `/bin/pwd`;
chomp $curdir;

chdir "gr";

require "html.pl";
require "cgi.pl";
require "data.pl";
require "cookie.pl";
require "email.pl";
require "gameserver.pl";
require "processinput.pl";

CgiPrintHeader();

#%c = &CookieRead();

%r = &DataGetSessionRec($c{sid});

chdir "$curdir";


###########################
# check if the tournament is over
$res = `/bin/grep "^result" rounds/tournState`;
if ($res eq ""){
  HtmlMessagePage("Tournament Not Over", "You cannot play the best bots until the tournament is over");
  exit;
}

###########################
# determine the two best bots
if (! -e "playBestBots.cfg"){
  HtmlMessagePage("Best Bots Needed", "The best bots have not been defined yet");
  exit;
}
open(FH, "<playBestBots.cfg");
$l = join('', <FH>);
close FH;
($bot1, $bot2) = ($l =~ m/(\w+)\s+(\w+)/s);
if (($bot1 eq '') || ($bot2 eq '')){
  HtmlMessagePage("Best Bots Not Set", "The best bots have not been entered");
  exit;
}

($starttime) = ($l =~ m/\bstart\s*=\s*([^\n]+)\n/s);
($endtime) = ($l =~ m/\bend\s*=\s*([^\n]+)\n/s);


###########################
# get the time period for the preChallange games 

if ($starttime eq ''){
  &HtmlErrorPage("Need Start Time", "Sorry no start time was given");
  exit;
}
if ($endtime eq ''){
  &HtmlErrorPage("Need End Time", "Sorry no end time was given");
  exit;
}

$startts = `date +%s -d "$starttime"`;
$endts = `date +%s -d "$endtime"`;

if ($startts eq ''){
  &HtmlErrorPage("Need Start Time", "Start time format seems bad.");
  exit;
}
if ($endts eq ''){
  &HtmlErrorPage("Need End Time", "End time format seems bad.");
  exit;
}

#$startts = $startts - 8*86400;


###########################
# get the game record against the tow bots during the time period

#DataGetPastGameRec("(wusername='$bot1' or wusername='$bot2' or busername='$bot1' or busername='$bot2') and ((wtype='b' and btype='h') or (wtype='h' and btype='b')) and rated=1 and startts>$startts and startts<$endts");

%g = DataGetPastGameRec("(wusername='$bot1' or wusername='$bot2' or busername='$bot1' or busername='$bot2') and rated=1 and startts>$startts and startts<$endts");

$sth = Db_getSth();

while($g{id}){
  my(%x);
  if ($g{wtype} eq 'b' and $g{btype} eq 'b'){ goto nextGame; }
  if ($g{wtype} eq 'h' and $g{btype} eq 'h'){ goto nextGame; }
#print "&nbsp; &nbsp; $g{id} $g{wusername} $g{busername}<br>\n";
  $p = 'w'; $b = 'b';
  if ($g{wtype} eq 'b'){
    $p = 'b'; $b = 'w';
  }
  if ($g{"${b}username"} eq $bot1){
    if ($b eq 'w'){ $i = 0; }
    else{ $i = 2; }
  }
  else{
    if ($b eq 'w'){ $i = 1; }
    else{ $i = 3; }
  }
  %x = %g;
  if ($x{result} eq 'd'){ $x{botwon} = 0.5; }
  else{
    $x{botwon} = (($x{result} eq 'w' and $x{wtype} eq 'b') or ($x{result} eq 'b' and $x{btype} eq 'b'))?1:0;
  }
  if ($x{botwon} == 1){ $x{star} = "*"; }
  if ($x{botwon} == 0.5){ $x{star} = "="; }
#print qq(    $g{"${p}username"} $i\n);
  $r{$g{"${p}username"}}[$i] = \%x;

nextGame:
  %g = DataGetNextRec($sth);
}

#print "\n\n";

while(($p,$v) = each(%r)){
  
  $bot1t = 0;
  $bot2t = 0;
  if ($r{$p}[0] and $r{$p}[1]){
    $bot1t += $r{$p}[0]->{botwon};
    $bot2t += $r{$p}[1]->{botwon};
  }
  if ($r{$p}[2] and $r{$p}[3]){
    $bot1t += $r{$p}[2]->{botwon};
    $bot2t += $r{$p}[3]->{botwon};
  }
  $bot1n += $bot1t;
  $bot2n += $bot2t;

  $row = <<EOM;
<tr>
<td>$p</p>
<td>$r{$p}[0]->{star} <a target=_blank href="/arimaa/gameroom/comments.cgi?gid=$r{$p}[0]->{id}">$r{$p}[0]->{termination} $r{$p}[0]->{plycount}</a></td>
<td>$r{$p}[2]->{star} <a target=_blank href="/arimaa/gameroom/comments.cgi?gid=$r{$p}[2]->{id}">$r{$p}[2]->{termination} $r{$p}[2]->{plycount}</a></td>
<td>$bot1t</td>
<td>$r{$p}[1]->{star} <a target=_blank href="/arimaa/gameroom/comments.cgi?gid=$r{$p}[1]->{id}">$r{$p}[1]->{termination} $r{$p}[1]->{plycount}</a></td>
<td>$r{$p}[3]->{star} <a target=_blank href="/arimaa/gameroom/comments.cgi?gid=$r{$p}[3]->{id}">$r{$p}[3]->{termination} $r{$p}[3]->{plycount}</a></td>
<td>$bot2t</td>
</tr>
EOM

  $rows .= $row;

#  print "$p $r{$p}[0]->{id} $r{$p}[1]->{id} $r{$p}[2]->{id} $r{$p}[3]->{id} \n";
#  print "$p $r{$p}[0]->{botwon} $r{$p}[1]->{botwon} $r{$p}[2]->{botwon} $r{$p}[3]->{botwon}   tot= $bot1t  $bot2t \n";
}

$page = <<EOM;

<table border=1>
  <tr>
<td><b>Player</b></td>
<td><b>$bot1<br>Gold</b></td>
<td><b>$bot1<br>Silver</b></td>
<td><b>$bot1<br>Points</b></td>
<td><b>$bot2<br>Gold</b></td>
<td><b>$bot2<br>Silver</b></td>
<td><b>$bot2<br>Points</b></td>
  </tr>
$rows
  <tr>
<td></td>
<td></td>
<td></td>
<td><b>$bot1n</b></td>
<td></td>
<td></td>
<td><b>$bot2n</b></td>
  </tr>
</table>
EOM

HtmlMessagePage("Bot Scores", $page);


exit;

